package org.diagbot.common.push.filter.pretreat;

import org.diagbot.common.push.bean.PreResult;
import org.diagbot.nlp.participle.ParticipleUtil;
import org.diagbot.nlp.participle.word.Lexeme;
import org.diagbot.nlp.participle.word.LexemePath;
import org.diagbot.nlp.util.NegativeEnum;
import org.diagbot.nlp.util.NlpUtil;

import java.util.List;

public class PretreatmentPacs extends Pretreatment {
    protected NegativeEnum[] nees_pacs_result = new NegativeEnum[]{NegativeEnum.PACS_RESULT, NegativeEnum.DISEASE};
    protected NegativeEnum[] nees_pacs_name = new NegativeEnum[]{NegativeEnum.PACS_NAME};
    public List<PreResult> analyze(String content) throws java.io.IOException{
        List<PreResult> preResultList = super.analyzeDefault(content);
        //pacs除了数值型需要转， 还需要对部分检查结果提取，以便做危机警示
        LexemePath<Lexeme> lexemes = ParticipleUtil.participle(content);

        Lexeme leftLexeme;
        for (int i = 0; i < lexemes.size(); i++) {
            Lexeme l = lexemes.get(i);
            if (NlpUtil.isFeature(l.getProperty(), nees_pacs_result) && i > 0) {
                int c = i - 1;
                while (c > -1) {
                    leftLexeme = lexemes.get(c);
                    if (NlpUtil.isFeature(leftLexeme.getProperty(), nees_pacs_name)) {
                        PreResult result = new PreResult();
                        result.setValue(l.getText());
                        result.setDetailName(leftLexeme.getText());
                        preResultList.add(result);
                        break;
                    }
                    c--;
                }

            }
        }

        return preResultList;
    }

    public PreResult createPreResult(LexemePath<Lexeme> lexemes, Lexeme lexeme, int index) {
        return super.createDefaultPreResult(lexemes, lexeme, index);
    }
}
